﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace InvokeMethodByName
{
	public partial class Form1 : Form
	{
		public Form1()
		{
			InitializeComponent();
		}

		private void invoke_method(string method_name)
		{
			MethodInfo		method		= MethodFinder.FindMethod(method_name);
			string			str_result	= "";

			if (method != null)
			{
				str_result = method.Invoke(this, null).ToString();
				MessageBox.Show(str_result);
			}
			else
				MessageBox.Show("Couldn't find method in loaded assemblies");
		}


		private void button1_Click(object sender, EventArgs e)
		{
			invoke_method("Method1");
		}

		private void button2_Click(object sender, EventArgs e)
		{
			invoke_method("Method2");
		}

		private void button3_Click(object sender, EventArgs e)
		{
			invoke_method("Method3");
		}

		private void button4_Click(object sender, EventArgs e)
		{
			invoke_method("Method4");
		}

		public static string Method3()
		{
			return "Hello, This is method 3. I live in this dialog class.";
		}



	}
}
